<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 02/13/2005 *
 * ===============                              Last change: 02/13/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : doubler.php                                      *
 * -------------------------------------------------------------------- *
 * Short description : Points doubler                                   *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Punkteverdoppler                                 *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Load security stuff here
require('inc/libs/security_functions.php');

// Init start time
$GLOBALS['startTime'] = microtime(true);

// Set module
$GLOBALS['module'] = 'doubler';
$GLOBALS['output_mode'] = 0;

// Load the required file(s)
require('inc/config-global.php');

// Set content type
setContentType('text/html');

// Is the 'doubler' extension active?
redirectOnUninstalledExtension('doubler');

// Probe for referal ID
if (isGetRequestElementSet('refid')) $GLOBALS['refid'] = getRequestElement('refid');

// Only check this if refid is provided!
if (determineReferalId() > 0) {
	// Do we have nickname or userid set?
	if (isNicknameUsed(determineReferalId())) {
		// Nickname in URL, so load the ID
		$result = SQL_QUERY_ESC("SELECT `userid`, `status` FROM `{?_MYSQL_PREFIX?}_user_data` WHERE `nickname`='%s' LIMIT 1",
			array(determineReferalId()), __FILE__, __LINE__);
	} else {
		// Direct userid entered
		$result = SQL_QUERY_ESC("SELECT `userid`, `status` FROM `{?_MYSQL_PREFIX?}_user_data` WHERE `userid`=%s LIMIT 1",
			array(determineReferalId()), __FILE__, __LINE__);
	}

	// Load data
	list($rid, $status_ref) = SQL_FETCHROW($result);
	$GLOBALS['refid'] = bigintval($rid);

	// Free memory
	SQL_FREERESULT($result);
} // END - if

// Init userid
$userid = 0;

// If no account was found set default refid and status to CONFIRMED
if (empty($GLOBALS['refid'])) {
	$GLOBALS['refid'] = getConfig('def_refid');
	$status = 'CONFIRMED';
} // END - if

// Init content array
$content = array(
	'message' => '',
);

// Begin with doubler script...
if (isFormSent()) {
	// Secure points (so only integer/double values are allowed
	setRequestPostElement('points', bigintval(postRequestElement('points')));

	// Begin with doubling process
	if ((isPostRequestElementSet('userid')) && (isPostRequestElementSet('pass')) && (isPostRequestElementSet('points'))) {
		// Probe for nickname extension and if a nickname was entered
		if (isNickNameUsed(postRequestElement('userid'))) {
			// Nickname in URL, so load the ID
			$result = SQL_QUERY_ESC("SELECT `userid`, `status`, `password` FROM `{?_MYSQL_PREFIX?}_user_data` WHERE `nickname`='%s' LIMIT 1",
				array(postRequestElement('userid')), __FILE__, __LINE__);
		} else {
			// Direct userid entered
			$result = SQL_QUERY_ESC("SELECT `userid`, `status, `password` FROM `{?_MYSQL_PREFIX?}_user_data` WHERE `userid`=%s LIMIT 1",
				array(bigintval(postRequestElement('userid'))), __FILE__, __LINE__);
		}

		// Load data
		list($userid, $status, $password) = SQL_FETCHROW($result);
		$userid = bigintval($userid);

		// Free result
		SQL_FREERESULT($result);

		// Remove any dots and unwanted chars from the points
		setRequestPostElement('points', bigintval(round(convertCommaToDot(postRequestElement('points')))));

		// Probe for enough points
		$probe_points = ((postRequestElement('points') >= getConfig('doubler_min')) && (postRequestElement('points') <= getConfig('doubler_max')));

		// Check all together
		if ((!empty($userid)) && ($password == generateHash(postRequestElement('pass'), substr($password, 0, -40))) && ($status == 'CONFIRMED') && ($probe_points)) {
			// Nickname resolved to a unique userid or direct userid entered by the member
			$GLOBALS['doubler_userid'] = $userid;

			// Calulcate points
			$points = countSumTotalData($userid, 'user_points', 'points') - countSumTotalData($userid, 'user_data', 'used_points');

			// So let's continue with probing his points amount
			if (($points - getConfig('doubler_left') - postRequestElement('points') * getConfig('doubler_charge')) >= 0) {
				// Enough points are left so let's continue with the doubling process
				// Create doubling "account" width *DOUBLED* points
				SQL_QUERY_ESC("INSERT INTO `{?_MYSQL_PREFIX?}_doubler` (`userid`, `refid`, `points`, `remote_ip`, `timemark`, `completed`, `is_ref`) VALUES ('%s','%s','%s','".detectRemoteAddr()."', UNIX_TIMESTAMP(), 'N','N')",
					array($userid, determineReferalId(), bigintval(postRequestElement('points') * 2)), __FILE__, __LINE__);

				// Subtract entered points
				subtractPoints('doubler', $userid, postRequestElement('points'));

				// Add points to "total payed" including charge
				$points = postRequestElement('points') - postRequestElement('points') * getConfig('doubler_charge');
				updateConfiguration('doubler_points', $points, '+');
				incrementConfigEntry('doubler_points', $points);

				// Add second line for the referal but only when userid != refid
				if ((determineReferalId() > 0) && (determineReferalId() != $userid)) {
					// Okay add a refid line and apply refid percents
					SQL_QUERY_ESC("INSERT INTO `{?_MYSQL_PREFIX?}_doubler` (`userid`, `refid`, `points`, `remote_ip`, `timemark`, `completed`, `is_ref`) VALUES ('%s',0,'%s','".detectRemoteAddr()."',UNIX_TIMESTAMP(),'N','Y')",
						array(
							determineReferalId(),
							bigintval(postRequestElement('points') * 2 * getConfig('doubler_ref'))
						), __FILE__, __LINE__);

					// And that's why we don't want to you more than one referal level of doubler-points. ^^^
				} // END - if

				// Update usage counter
				updateConfiguration('doubler_counter', 1, '+');

				// Set constant
				$content['message'] = loadTemplate('doubler_reflink', true, postRequestElement('userid'));
			} else {
				// Not enougth points left
				$content['message'] = getMessage('DOUBLER_FORM_NO_POINTS_LEFT');
			}
		} elseif ($status == 'CONFIRMED') {
			// Account is unconfirmed!
			$content['message'] = getMessage('DOUBLER_FORM_WRONG_PASS');
		} elseif ($status == 'UNCONFIRMED') {
			// Account is unconfirmed!
			$content['message'] = getMessage('DOUBLER_FORM_STATUS_UNCONFIRMED');
		} elseif ($status == 'LOCKED') {
			// Account is locked by admin / holiday!
			$content['message'] = getMessage('DOUBLER_FORM_STATUS_LOCKED');
		} elseif (postRequestElement('points') < getConfig('doubler_min')) {
			// Not enougth points entered
			$content['message'] = getMessage('DOUBLER_FORM_POINTS_MIN');
		} elseif (postRequestElement('points') > getConfig('doubler_max')) {
			// Too much points entered
			$content['message'] = getMessage('DOUBLER_FORM_POINTS_MAX');
		} elseif (isNickNameUsed(postRequestElement('userid'))) {
			// Cannot resolv nickname -> userid
			$content['message'] = getMessage('DOUBLER_FORM_404_NICKNAME');
		} else {
			// Wrong password or account not found
			$content['message'] = getMessage('DOUBLER_FORM_404_MEMBER');
		}
	} elseif (!isPostRequestElementSet('userid')) {
		// Login not entered
		$content['message'] = getMessage('DOUBLER_FORM_404_LOGIN');
	} elseif (!isPostRequestElementSet('pass')) {
		// Password not entered
		$content['message'] = getMessage('DOUBLER_FORM_404_PASSWORD');
	} elseif (!isPostRequestElementSet('points')) {
		// points not entered
		$content['message'] = getMessage('DOUBLER_FORM_404_POINTS');
	}
}

// Shall I check for points immediately?
if (getConfig('doubler_send_mode') == 'DIRECT') loadInclude('inc/mails/doubler_mails.php');

// Output header
loadIncludeOnce('inc/header.php');

// Banner in text
$content['banner'] = loadTemplate('doubler_banner', true);

// Load header/footer templates
$content['header'] = loadTemplate('doubler_header', true);
$content['footer'] = loadTemplate('doubler_footer', true);

if (!empty($userid)) {
	// Transfer userid/nickname to constant
	$content['refid'] = $userid;
} else {
	// Transfer userid/nickname to constant
	$content['refid'] = determineReferalId();
}

// Percent values etc.
$content['charge'] = translateComma(getConfig('doubler_charge') * 100);
$content['ref']    = translateComma(getConfig('doubler_ref') * 100);
$content['total']  = translateComma(getConfig('doubler_points'));
$content['min']    = translateComma(getConfig('doubler_min'));
$content['max']    = translateComma(getConfig('doubler_max'));

// Text "Enter login"
if (isExtensionActive('nickname')) {
	// Choose login/nickname
	$content['enter_login'] = getMessage('GUEST_ENTER_LOGIN_NICKNAME');
} else {
	// Simple login ID
	$content['enter_login'] = getMessage('GUEST_ENTER_LOGIN');
}

// Which mail-send-mode did the admin setup?
$content['payout_time'] = getMessage('DOUBLER_PAYOUT_TIME_' . getConfig('doubler_send_mode'));

// Generate table with already payed out doubles
$content['payout_history'] = generateDoublerTable('0', 'Y', 'N', 'DESC');

// Generate timemark
$content['timeout_mark'] = createFancyTime(getConfig('doubler_timeout'));

// Points left to doubler
$content['left'] = translateComma(DOUBLER_GET_TOTAL_POINTS_LEFT());

// Output neccessary form for this
loadTemplate('doubler_index', false, $content);

// Output footer
loadIncludeOnce('inc/footer.php');

// [EOF]
?>
